Bug 1066672 - Review Request: openstack-tripleo-image-elements - OpenStack TripleO Image Elements
Review Request: openstack-tripleo-image-elements - OpenStack TripleO Image El...
Status: ON_QA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FE-NEEDSPONSOR
  Show dependency treegraph
 
Reported: 2014-02-18 15:56 EST by James Slagle
Modified: 2016-04-18 20:44 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
sdake: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description James Slagle 2014-02-18 15:56:27 EST
Spec URL: https://raw.github.com/agroup/tripleo-rpm-spec-files/master/tripleo-image-elements/openstack-tripleo-image-elements.spec
SRPM URL: http://repos.fedorapeople.org/repos/openstack-m/openstack-m/fedora-20/SRPMS/openstack-tripleo-image-elements-0.5.1-1.fc20.src.rpm
Description: OpenStack TripleO Image Elements is a collection of elements for
diskimage-builder that can be used to build OpenStack images for the TripleO
program.

Fedora Account System Username: slagle

koji scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=6544566

This is one of my first package submissions for Fedora, and I need a sponsor. I have a few more package review requests that I'll be submitting for the other OpenStack TripleO related projects.
Comment 1 James Slagle 2014-02-18 15:58:32 EST
There are some rpmlint errors in this package for scripts that have a shebang line, but are not +x. I can submit patches for that upstream if needed.

There are also some errors for 0-byte files. These files are required to be present by this package.
Comment 2 Steven Dake 2014-02-19 10:27:44 EST
James,

I'll sponsor you.

Please provide some links to other bugs where you have done package reviews in the past.
Comment 5 Steven Dake 2014-03-10 17:47:49 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated", "*No copyright* Apache (v2.0)".
     2 files have unknown license. Detailed output of licensecheck in
     /home/sdake/fedora-review/1066672-openstack-tripleo-image-
     elements/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 61440 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep
===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
Rpmlint
-------
Checking: openstack-tripleo-image-elements-0.6.0-2.fc20.noarch.rpm
          openstack-tripleo-image-elements-0.6.0-2.fc20.src.rpm
openstack-tripleo-image-elements.noarch: E: non-executable-script /usr/share/tripleo-image-elements/tempest/tests2skip.py 0644L /usr/bin/python
openstack-tripleo-image-elements.noarch: E: non-executable-script /usr/share/tripleo-image-elements/snmpd/files/check_proc_open_files.py 0644L /usr/bin/env
openstack-tripleo-image-elements.noarch: W: hidden-file-or-dir /usr/share/tripleo-image-elements/os-apply-config/os-config-applier/.os-config-applier

Is there some reason there is a hidden file in this directory?  This seems suspect to me.

openstack-tripleo-image-elements.noarch: E: zero-length /usr/share/tripleo-image-elements/os-apply-config/os-config-applier/.os-config-applier
openstack-tripleo-image-elements.noarch: W: hidden-file-or-dir /usr/share/tripleo-image-elements/os-apply-config/os-apply-config/.os-config-applier
openstack-tripleo-image-elements.noarch: E: zero-length /usr/share/tripleo-image-elements/os-apply-config/os-apply-config/.os-config-applier
openstack-tripleo-image-elements.noarch: E: non-executable-script 

this wont work with DIB - it requires files to be +x

/usr/share/tripleo-image-elements/iptables/bin/add-rule 0644L /bin/bash
openstack-tripleo-image-elements.noarch: E: non-executable-script


this wont work with DIB - it requires files to be +x
/usr/share/tripleo-image-elements/openstack-ssl/os-refresh-config/pre-configure.d/70-stunnel-permissions 0644L /bin/bash

this wont work with DIB - it requires files to be +x

openstack-tripleo-image-elements.noarch: W: hidden-file-or-dir /usr/share/tripleo-image-elements/horizon/os-apply-config/etc/horizon/.secret_key_store

Does this file really need to be hidden?

openstack-tripleo-image-elements.src:3: W: mixed-use-of-spaces-and-tabs (spaces: line 3, tab: line 1)

please fix the tab/spacing usage and stick to one.

2 packages and 0 specfiles checked; 6 errors, 4 warnings.

Rpmlint (installed packages)
----------------------------
# rpmlint openstack-tripleo-image-elements
openstack-tripleo-image-elements.noarch: W: spelling-error Summary(en_US) diskimage -> disk image, disk-image, disparage
openstack-tripleo-image-elements.noarch: W: spelling-error %description -l en_US diskimage -> disk image, disk-image, disparage
openstack-tripleo-image-elements.noarch: E: non-executable-script /usr/share/tripleo-image-elements/tempest/tests2skip.py 0644L /usr/bin/python
openstack-tripleo-image-elements.noarch: E: non-executable-script /usr/share/tripleo-image-elements/snmpd/files/check_proc_open_files.py 0644L /usr/bin/env
openstack-tripleo-image-elements.noarch: W: hidden-file-or-dir /usr/share/tripleo-image-elements/os-apply-config/os-config-applier/.os-config-applier
openstack-tripleo-image-elements.noarch: E: zero-length /usr/share/tripleo-image-elements/os-apply-config/os-config-applier/.os-config-applier
openstack-tripleo-image-elements.noarch: W: hidden-file-or-dir /usr/share/tripleo-image-elements/os-apply-config/os-apply-config/.os-config-applier
openstack-tripleo-image-elements.noarch: E: zero-length /usr/share/tripleo-image-elements/os-apply-config/os-apply-config/.os-config-applier
Comment 6 Steven Dake 2014-03-10 17:49:36 EDT
James,

Please add a comment as to where the patches come.  If they are just the results of git format-patch -16 off master, that is fine, just indicate that.

The rest of the package looks pretty good.

Please resolve the rpmlint issues and submit a new spec/SRPM.  Afterwards I'll approve the package and add you to the fedora packagers group.
Comment 7 James Slagle 2014-03-11 18:10:32 EDT
Spec URL: https://raw.github.com/agroup/tripleo-rpm-spec-files/master/tripleo-image-elements/openstack-tripleo-image-elements.spec
SRPM URL: http://repos.fedorapeople.org/repos/openstack-m/openstack-m/fedora-20/SRPMS/openstack-tripleo-image-elements-0.6.0-3.fc20.src.rpm


(In reply to Steven Dake from comment #5)
> ===== EXTRA items =====
> 
> Generic:
> [x]: Rpmlint is run on all installed packages.
>      Note: There are rpmlint messages (see attachment).
> [x]: Spec file according to URL is the same as in SRPM.
> Rpmlint
> -------
> Checking: openstack-tripleo-image-elements-0.6.0-2.fc20.noarch.rpm
>           openstack-tripleo-image-elements-0.6.0-2.fc20.src.rpm
> openstack-tripleo-image-elements.noarch: E: non-executable-script
> /usr/share/tripleo-image-elements/tempest/tests2skip.py 0644L /usr/bin/python
> openstack-tripleo-image-elements.noarch: E: non-executable-script
> /usr/share/tripleo-image-elements/snmpd/files/check_proc_open_files.py 0644L
> /usr/bin/env
> openstack-tripleo-image-elements.noarch: W: hidden-file-or-dir
> /usr/share/tripleo-image-elements/os-apply-config/os-config-applier/.os-
> config-applier
> 
> Is there some reason there is a hidden file in this directory?  This seems
> suspect to me.

The reason is you can't have empty directories in git, and the os-apply-config element expects this directory to exist when the element is installed in an image. So, that's why the hidden file was added.

> openstack-tripleo-image-elements.noarch: E: non-executable-script 
> 
> this wont work with DIB - it requires files to be +x
> 
> /usr/share/tripleo-image-elements/iptables/bin/add-rule 0644L /bin/bash

add-rule is only run on built images at instance run time. When it's installed onto the image, it is 755. But, there's no need for it to be +x here.  I could submit a patch upstream, but the only point of that would be to make rpmlint happy :).

> openstack-tripleo-image-elements.noarch: E: non-executable-script
> 
> 
> this wont work with DIB - it requires files to be +x
> /usr/share/tripleo-image-elements/openstack-ssl/os-refresh-config/pre-
> configure.d/70-stunnel-permissions 0644L /bin/bash
> 
> this wont work with DIB - it requires files to be +x

This one has been fixed upstream, and I added the new patch to the rpm build.

> 
> openstack-tripleo-image-elements.noarch: W: hidden-file-or-dir
> /usr/share/tripleo-image-elements/horizon/os-apply-config/etc/horizon/.
> secret_key_store
> 
> Does this file really need to be hidden?

You can configure horizon to use any file for the secret key, but the upstream convention (and how the element works) is to use the hidden file. See:
http://git.openstack.org/cgit/openstack/horizon/tree/openstack_dashboard/settings.py#n239

> 
> openstack-tripleo-image-elements.src:3: W: mixed-use-of-spaces-and-tabs
> (spaces: line 3, tab: line 1)
> 
> please fix the tab/spacing usage and stick to one.

Fixed.
Comment 8 Steven Dake 2014-03-18 13:05:06 EDT
(In reply to James Slagle from comment #7)
> Spec URL:
> https://raw.github.com/agroup/tripleo-rpm-spec-files/master/tripleo-image-
> elements/openstack-tripleo-image-elements.spec
> SRPM URL:
> http://repos.fedorapeople.org/repos/openstack-m/openstack-m/fedora-20/SRPMS/
> openstack-tripleo-image-elements-0.6.0-3.fc20.src.rpm
> 
> 
> (In reply to Steven Dake from comment #5)
> > ===== EXTRA items =====
> > 
> > Generic:
> > [x]: Rpmlint is run on all installed packages.
> >      Note: There are rpmlint messages (see attachment).
> > [x]: Spec file according to URL is the same as in SRPM.
> > Rpmlint
> > -------
> > Checking: openstack-tripleo-image-elements-0.6.0-2.fc20.noarch.rpm
> >           openstack-tripleo-image-elements-0.6.0-2.fc20.src.rpm
> > openstack-tripleo-image-elements.noarch: E: non-executable-script
> > /usr/share/tripleo-image-elements/tempest/tests2skip.py 0644L /usr/bin/python
> > openstack-tripleo-image-elements.noarch: E: non-executable-script
> > /usr/share/tripleo-image-elements/snmpd/files/check_proc_open_files.py 0644L
> > /usr/bin/env
> > openstack-tripleo-image-elements.noarch: W: hidden-file-or-dir
> > /usr/share/tripleo-image-elements/os-apply-config/os-config-applier/.os-
> > config-applier
> > 
> > Is there some reason there is a hidden file in this directory?  This seems
> > suspect to me.
> 
> The reason is you can't have empty directories in git, and the
> os-apply-config element expects this directory to exist when the element is
> installed in an image. So, that's why the hidden file was added.
> 
Couldn't you just use the %dir directive to create the directory in /usr/share/tripleo-image-elments/os-apply-config/os-config-applier?

I am missing how git is involved in the hidden file, other then the need to have the empty directory.

My recommendation would be as follows:
1) if the empty file is in the upstream git repo to allow the directory to be present in git, the upstream would be better served by an empty README, rather then a hidden file which may cause confusion.  Hidden files indicate configuration options typically, rather then placeholders to workaround git issues.  If this is the case, I'd suggest filing a bug with upstream to indicate files prepended with period are used for configuration, and to rename the file to something that folks can see (such as README).  I won't block the review for this condition but do have an expectation that an upstream bug be filed.

2) If the empty file is added by the packager as part of the git export process, a %dir should fix the problem.

Could you get back to me on this point?

> > openstack-tripleo-image-elements.noarch: E: non-executable-script 
> > 
> > this wont work with DIB - it requires files to be +x
> > 
> > /usr/share/tripleo-image-elements/iptables/bin/add-rule 0644L /bin/bash
> 
> add-rule is only run on built images at instance run time. When it's
> installed onto the image, it is 755. But, there's no need for it to be +x
> here.  I could submit a patch upstream, but the only point of that would be
> to make rpmlint happy :).
> 

ok then rpmlint warning can be ignored

> > openstack-tripleo-image-elements.noarch: E: non-executable-script
> > 
> > 
> > this wont work with DIB - it requires files to be +x
> > /usr/share/tripleo-image-elements/openstack-ssl/os-refresh-config/pre-
> > configure.d/70-stunnel-permissions 0644L /bin/bash
> > 
> > this wont work with DIB - it requires files to be +x
> 
> This one has been fixed upstream, and I added the new patch to the rpm build.
> 

nice

> > 
> > openstack-tripleo-image-elements.noarch: W: hidden-file-or-dir
> > /usr/share/tripleo-image-elements/horizon/os-apply-config/etc/horizon/.
> > secret_key_store
> > 
> > Does this file really need to be hidden?
> 
> You can configure horizon to use any file for the secret key, but the
> upstream convention (and how the element works) is to use the hidden file.
> See:
> http://git.openstack.org/cgit/openstack/horizon/tree/openstack_dashboard/
> settings.py#n239
> 

if that is the upstream convention then that wfm.

> > 
> > openstack-tripleo-image-elements.src:3: W: mixed-use-of-spaces-and-tabs
> > (spaces: line 3, tab: line 1)
> > 
> > please fix the tab/spacing usage and stick to one.
> 
> Fixed.

nice
Comment 9 Steven Dake 2014-03-18 13:06:35 EDT
James,

I've gone through the review and the comments thus far, and this package is almost ready for approval.  Could you address the question/suggestion in Comment #8 related to the empty git file placeholder, submit a new package if necessary, and then I'll approve the package?

Thanks
-steve
Comment 10 James Slagle 2014-03-18 17:32:16 EDT
Spec URL: https://raw.github.com/agroup/tripleo-rpm-spec-files/master/tripleo-image-elements/openstack-tripleo-image-elements.spec
SRPM URL: http://repos.fedorapeople.org/repos/openstack-m/openstack-m/fedora-20/SRPMS/openstack-tripleo-image-elements-0.6.0-3.fc20.src.rpm

I submitted an upstream patch so the hidden files aren't needed under os-apply-config and os-config-applier:
https://review.openstack.org/#/c/81368/

I added that patch to the RPM as patch 0018.
Comment 12 Steven Dake 2014-03-19 20:18:30 EDT
Comment #11 package APPROVED.
Comment 13 James Slagle 2014-03-20 15:20:39 EDT
New Package SCM Request
=======================
Package Name: openstack-tripleo-image-elements
Short Description: OpenStack TripleO Image Elements
Owners: slagle
Branches: f20
InitialCC:
Comment 14 Jon Ciesla 2014-03-20 16:08:33 EDT
Git done (by process-git-requests).
Comment 15 Fedora Update System 2014-03-21 15:31:30 EDT
openstack-tripleo-image-elements-0.6.3-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/openstack-tripleo-image-elements-0.6.3-1.fc20
Comment 16 Fedora Update System 2014-03-23 00:43:45 EDT
openstack-tripleo-image-elements-0.6.3-1.fc20 has been pushed to the Fedora 20 testing repository.
Comment 18 Upstream Release Monitoring 2015-10-13 07:08:10 EDT
social's scratch build of openstack-puppet-modules?#db4e135626252ebf0b23b8a0e6e98ce0dcf2f9e6 for git://pkgs.fedoraproject.org/openstack-puppet-modules?#db4e135626252ebf0b23b8a0e6e98ce0dcf2f9e6 and rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11426591

Note You need to log in before you can comment on or make changes to this bug.